' 
'  JAZZAge COM for PB/DLL PB/CC
'  Copyright (c) 1999 JAZZAge Software SARL
'  www.jazzagesoft.com
' 

'
' VARIANT structures and API
'
UNION VARIANTVALUE
  lVal AS LONG
  bVal AS BYTE
  iVal AS INTEGER
  fltVal AS SINGLE
  dblVal AS DOUBLE
  boolVal AS WORD
  scode AS DWORD
  cyVal AS CUR
  date AS SINGLE
  bstrVal AS DWORD
  punkVal AS DWORD
  pdispVal AS DWORD
  parray AS DWORD
  pbVal AS BYTE PTR
  piVal AS INTEGER PTR
  plVal AS LONG PTR
  pfltVal AS SINGLE PTR
  pdblVal AS DOUBLE PTR
  pboolVal AS WORD PTR
  pscode AS DWORD PTR
  pcyVal AS CUR PTR
  pdate AS SINGLE PTR
  pbstrVal AS DWORD PTR
  ppunkVal AS DWORD PTR
  ppdispVal AS DWORD PTR
  pbyref AS BYTE  PTR
  cVal AS BYTE
  uiVal AS WORD
  ulVal AS DWORD
  intVal AS LONG
  uintVal AS DWORD
  pcVal AS BYTE PTR
  puiVal AS WORD PTR
  pulVal AS DWORD PTR
  pintVal AS LONG PTR
  puintVal AS DWORD PTR
END UNION

TYPE VARIANT
  vt AS WORD
  wReserved1 AS WORD
  wReserved2 AS WORD
  wReserved3 AS WORD
  Value AS VARIANTVALUE
END TYPE

TYPE MULTI_QI
  pIID AS DWORD
  pItf AS DWORD
  hr AS DWORD
END TYPE

TYPE COSERVERINFO
  dwReserved1 AS DWORD
  pwszName AS DWORD
  pAuthInfo AS DWORD
  dwReserved2 AS DWORD
END TYPE

TYPE SAFEARRAYBOUND
  cElements AS DWORD
  lLbound AS LONG
END TYPE

TYPE SAFEARRAY
  cDims AS WORD
  fFeatures AS WORD
  cbElements AS DWORD
  cLocks AS DWORD
  pvData AS DWORD
  rgsabound(0 to 1) AS SAFEARRAYBOUND
END TYPE

%VARIANT_NOVALUEPROP=1

%VT_EMPTY=0
%VT_NULL=1
%VT_I2=2
%VT_I4=3
%VT_R4=4
%VT_R8=5
%VT_CY=6
%VT_DATE=7
%VT_BSTR=8
%VT_DISPATCH=9
%VT_ERROR=10
%VT_BOOL=11
%VT_VARIANT=12
%VT_UNKNOWN=13
%VT_DECIMAL=14
%VT_I1=16
%VT_UI1=17
%VT_UI2=18
%VT_UI4=19
%VT_I8=20
%VT_UI8=21
%VT_INT=22
%VT_UINT=23
%VT_VOID=24
%VT_HRESULT=25
%VT_PTR=26
%VT_SAFEARRAY=27
%VT_CARRAY=28
%VT_USERDEFINED=29
%VT_LPSTR=30
%VT_LPWSTR=31
%VT_FILETIME=64
%VT_BLOB=65
%VT_STREAM=66
%VT_STORAGE=67
%VT_STREAMED_OBJECT=68
%VT_STORED_OBJECT=69
%VT_BLOB_OBJECT=70
%VT_CF=71
%VT_CLSID=72
%VT_VECTOR=&H1000
%VT_ARRAY=&H2000
%VT_BYREF=&H4000

%JADISP_E_PARAMNOTFOUND=&H80020004

DECLARE FUNCTION VariantChangeType LIB "oleaut32.DLL" ALIAS "VariantChangeType" (BYREF pvargDest AS VARIANT,BYREF pvargSrc AS VARIANT,BYVAL wFlags AS WORD,BYVAL vtNew AS WORD) AS DWORD
DECLARE FUNCTION VariantClear LIB "oleaut32.DLL" ALIAS "VariantClear" (BYREF pvarg AS VARIANT) AS DWORD
DECLARE FUNCTION VariantCopy LIB "oleaut32.DLL" ALIAS "VariantCopy" (BYREF pvargDest AS VARIANT,BYREF pvargSrc AS VARIANT) AS DWORD
DECLARE FUNCTION VariantCopyInd LIB "oleaut32.DLL" ALIAS "VariantCopyInd" (BYREF pvargDest AS VARIANT,BYREF pvargSrc AS VARIANT) AS DWORD
DECLARE SUB VariantInit LIB "oleaut32.DLL" ALIAS "VariantInit" (BYREF pvarg AS VARIANT)

'
' BSTR API
'
DECLARE FUNCTION SysAllocString LIB "oleaut32.DLL" ALIAS "SysAllocString" (BYREF pOleSZ AS WORD) AS DWORD
DECLARE FUNCTION SysAllocStringLen LIB "oleaut32.DLL" ALIAS "SysAllocStringLen" (BYREF pOCH AS WORD,BYVAL cOCH AS DWORD) AS DWORD
DECLARE SUB SysFreeString LIB "oleaut32.DLL" ALIAS "SysFreeString" (BYVAL hBSTR AS DWORD)
DECLARE FUNCTION SysReAllocString LIB "oleaut32.DLL" ALIAS "SysReAllocString" (BYREF hBSTR AS DWORD,BYREF pOleSZ AS WORD) AS WORD
DECLARE FUNCTION SysReAllocStringLen LIB "oleaut32.DLL" ALIAS "SysReAllocStringLen" (BYREF hBSTR AS DWORD,BYREF pOCH AS WORD,BYVAL cOCH AS DWORD) AS WORD
DECLARE FUNCTION SysStringLen LIB "oleaut32.DLL" ALIAS "SysStringLen" (BYVAL hBSTR AS DWORD) AS DWORD

'
' SAFEARRAY API
'

DECLARE FUNCTION SafeArrayCreate LIB "oleaut32.DLL" ALIAS "SafeArrayCreate"(BYVAL vt AS WORD,BYVAL cDims AS DWORD,BYREF rgsabounds AS SAFEARRAYBOUND) AS DWORD
DECLARE FUNCTION SafeArrayDestroy LIB "oleaut32.DLL" ALIAS "SafeArrayDestroy"(BYVAL hsa AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayGetDim LIB "oleaut32.DLL" ALIAS "SafeArrayGetDim"(BYVAL hsa AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayGetLBound LIB "oleaut32.DLL" ALIAS "SafeArrayGetLBound"(BYVAL hsa AS DWORD,BYVAL nDim AS DWORD,BYREF plLbound AS LONG) AS DWORD
DECLARE FUNCTION SafeArrayGetUBound LIB "oleaut32.DLL" ALIAS "SafeArrayGetUBound"(BYVAL hsa AS DWORD,BYVAL nDim AS DWORD,BYREF plUbound AS LONG) AS DWORD
DECLARE FUNCTION SafeArrayGetElemsize LIB "oleaut32.DLL" ALIAS "SafeArrayGetElemsize"(BYVAL hsa AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayPutElement LIB "oleaut32.DLL" ALIAS "SafeArrayPutElement"(BYVAL hsa AS DWORD,BYREF rgIndices AS LONG,BYVAL pvData AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayGetElement LIB "oleaut32.DLL" ALIAS "SafeArrayGetElement"(BYVAL hsa AS DWORD,BYREF rgIndices AS LONG,BYVAL pvData AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayLock LIB "oleaut32.DLL" ALIAS "SafeArrayLock"(BYVAL hsa AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayUnlock LIB "oleaut32.DLL" ALIAS "SafeArrayUnlock"(BYVAL hsa AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayCopy LIB "oleaut32.DLL" ALIAS "SafeArrayCopy"(BYVAL hsa AS DWORD,BYREF phsaOut AS DWORD) AS DWORD
DECLARE FUNCTION SafeArrayRedim LIB "oleaut32.DLL" ALIAS "SafeArrayRedim"(BYVAL hsa AS DWORD,BYREF psaboundNew AS SAFEARRAYBOUND) AS DWORD

'
' COM constants and API
'
''''''''$INCLUDE "STDOLE32.inc"

%COINIT_APARTMENTTHREADED = &H2 ' Apartment model
%COINIT_MULTITHREADED     = &H0 ' OLE calls objects on any thread.

%CLSCTX_INPROC_SERVER   = 1
%CLSCTX_INPROC_HANDLER  = 2
%CLSCTX_LOCAL_SERVER    = 4
%CLSCTX_REMOTE_SERVER   = 16
%CLSCTX_SERVER			= 21
%CLSCTX_ALL				= 23

DECLARE FUNCTION CoInitialize LIB "OLE32.DLL" ALIAS "CoInitialize" (BYVAL pvReserved AS DWORD) AS DWORD
DECLARE FUNCTION CoInitializeEx LIB "OLE32.DLL" ALIAS "CoInitializeEx" (BYVAL pvReserved AS DWORD,BYVAL dwCoInit AS DWORD) AS DWORD
DECLARE SUB CoUninitialize LIB "OLE32.DLL" ALIAS "CoUninitialize" ()

DECLARE FUNCTION CoCreateInstance LIB "OLE32.DLL" ALIAS "CoCreateInstance" (BYREF rclsid AS GUID,BYVAL pUnkOuter AS DWORD,BYVAL dwClsContext AS DWORD,BYREF riid AS GUID,BYREF pInterface AS DWORD) AS DWORD
DECLARE FUNCTION CoCreateInstanceEx LIB "OLE32.DLL" ALIAS "CoCreateInstanceEx"(BYREF rclsid AS GUID,BYVAL pUnkOuter AS DWORD,BYVAL dwClsContext AS DWORD,BYREF pServerInfo AS COSERVERINFO,BYVAL cmq AS DWORD,BYREF pResults AS MULTI_QI) AS DWORD

DECLARE FUNCTION CoMarshalInterThreadInterfaceInStream LIB "OLE32.DLL" ALIAS "CoMarshalInterThreadInterfaceInStream" (BYREF rclsid AS GUID,BYVAL pUnkOuter AS DWORD,BYREF ppStm AS DWORD) AS DWORD
DECLARE FUNCTION CoGetInterfaceAndReleaseStream LIB "OLE32.DLL" ALIAS "CoGetInterfaceAndReleaseStream"(BYVAL pStm AS DWORD,BYREF riid AS GUID,BYREF ppInterface AS DWORD) AS DWORD

'
' JA Helper general functions
'
SUB JAAddRef(BYREF pUnk AS DWORD)
  IF (pUnk <> 0) THEN
    IUnknown_AddRef pUnk
  END IF
END SUB

SUB JARelease(BYREF pUnk AS DWORD)
  IF (pUnk <> 0) THEN
    IUnknown_Release pUnk
	pUnk=0
  END IF
END SUB

FUNCTION COMFAILED(BYVAL hResult AS DWORD) AS WORD
  IF (hResult AND &H80000000) THEN
    COMFAILED=1
  ELSE
    COMFAILED=0
  END IF
END FUNCTION

FUNCTION COMSCODE(BYVAL hResult AS DWORD) AS WORD
  COMSCODE=hResult AND &HFFFF
END FUNCTION

'
' JA Helper BSTR functions
'
FUNCTION JAAllocString(pSZ AS ASCIIZ) AS DWORD
LOCAL hbstr AS DWORD
LOCAL pchar AS BYTE PTR
LOCAL i AS DWORD
LOCAL strlen AS DWORD
DIM osz(1) AS WORD
  hbstr=0

  pchar=VARPTR(pSZ)
  strlen=0
  WHILE (@pchar <> 0)
    pchar=pchar+1
	strlen=strlen+1
  WEND

  REDIM osz(0 to strlen)

  pchar=VARPTR(pSZ)
  FOR i=0 TO strlen
    osz(i)=@pchar
    pchar=pchar+1
  NEXT i

  hbstr=SysAllocString(osz(0))

  JAAllocString=hbstr
END FUNCTION

FUNCTION JASetASCIIZToBSTR(hBstr AS DWORD,pSZ AS ASCIIZ) AS DWORD

  IF (hBstr <> 0) THEN
    SysFreeString hBstr
	hBstr=0
  END IF

  hBstr=JAAllocString(pSZ)

  JASetASCIIZToBSTR=hBstr
END FUNCTION

FUNCTION JAReadString(hBSTR AS DWORD,pSZ AS ASCIIZ) AS DWORD
LOCAL errcode AS DWORD
LOCAL strlen AS DWORD
LOCAL pchar AS BYTE PTR
LOCAL pochar AS WORD PTR
LOCAL i AS DWORD
  errcode=0
  pSZ=""

  IF (hBSTR=0) THEN
    errcode=1
    goto LXJAReadString
  END IF

  strlen=SysStringLen(hBSTR)
  pochar=hBSTR

  pchar=VARPTR(pSZ)
  FOR i=0 TO strlen
    @pchar=@pochar
    pchar=pchar+1
    pochar=pochar+2
  NEXT i

LXJAReadString:
  JAReadString=errcode
END FUNCTION

SUB JAFreeString(BYREF hBSTR AS DWORD)
  IF (hBSTR <> 0) THEN
    SysFreeString hBSTR
	hBSTR=0
  END IF
END SUB

'
' JA Helper VARIANT functions
'
'SUB JASetOptionalParameter(BYREF Var AS VARIANT)
'  Var.vt=%VT_ERROR
'  Var.Value.scode=%JADISP_E_PARAMNOTFOUND
'END SUB

SUB JASetOptionalParameter(BYREF Var AS VARIANT)
LOCAL pvt AS WORD PTR
LOCAL pscode AS DWORD PTR
  pvt=VARPTR(Var)
  @pvt=%VT_ERROR
  pscode=VARPTR(Var)+8
  @pscode=%JADISP_E_PARAMNOTFOUND
END SUB


FUNCTION JAGetVariantVTString(BYVAL VT AS WORD) AS STRING

  JAGetVariantVTString=""

  SELECT CASE VT

      CASE %VT_EMPTY
	    JAGetVariantVTString="%VT_EMPTY"

      CASE %VT_NULL
	    JAGetVariantVTString="%VT_NULL"

      CASE %VT_I1
	    JAGetVariantVTString="%VT_I1"

      CASE %VT_UI1
	    JAGetVariantVTString="%VT_UI1"

      CASE %VT_I2
	    JAGetVariantVTString="%VT_I2"

      CASE %VT_UI2
	    JAGetVariantVTString="%VT_UI2"

      CASE %VT_I4
	    JAGetVariantVTString="%VT_I4"

      CASE %VT_UI4
	    JAGetVariantVTString="%VT_UI4"

      CASE %VT_I8
	    JAGetVariantVTString="%VT_I8"

      CASE %VT_UI8
	    JAGetVariantVTString="%VT_UI8"

      CASE %VT_INT
	    JAGetVariantVTString="%VT_INT"

      CASE %VT_UINT
	    JAGetVariantVTString="%VT_UINT"

      CASE %VT_VOID
	    JAGetVariantVTString="%VT_VOID"

      CASE %VT_R4
	    JAGetVariantVTString="%VT_R4"

      CASE %VT_R8
	    JAGetVariantVTString="%VT_R8"

      CASE %VT_BOOL
	    JAGetVariantVTString="%VT_BOOL"

      CASE %VT_CY
	    JAGetVariantVTString="%VT_CY"

      CASE %VT_DATE
	    JAGetVariantVTString="%VT_DATE"

      CASE %VT_UNKNOWN
	    JAGetVariantVTString="%VT_UNKNOWN"

      CASE %VT_DISPATCH
	    JAGetVariantVTString="%VT_DISPATCH"

      CASE %VT_BSTR
	    JAGetVariantVTString="%VT_BSTR"

      CASE %VT_ERROR
	    JAGetVariantVTString="%VT_ERROR"

      CASE %VT_VARIANT
	    JAGetVariantVTString="%VT_VARIANT"

      CASE %VT_HRESULT
	    JAGetVariantVTString="%VT_HRESULT"

      CASE %VT_LPSTR
	    JAGetVariantVTString="%VT_LPSTR"

      CASE %VT_LPWSTR
	    JAGetVariantVTString="%VT_LPWSTR"

      CASE %VT_CLSID
	    JAGetVariantVTString="%VT_CLSID"

  END SELECT

END FUNCTION

FUNCTION JAGetVariantTextTypeAndContent(BYREF Var AS VARIANT) AS STRING
LOCAL psz AS ASCIIZ*4096
LOCAL vtarray AS WORD
LOCAL scontent AS STRING

  JAGetVariantTextTypeAndContent=JAGetVariantVTString(Var.vt)

  SELECT CASE Var.vt

      CASE %VT_I1
	    JAGetVariantTextTypeAndContent="%VT_I1="+STR$(Var.Value.bVal)

      CASE %VT_UI1
	    JAGetVariantTextTypeAndContent="%VT_UI1="+STR$(Var.Value.bVal)

      CASE %VT_I2
	    JAGetVariantTextTypeAndContent="%VT_I2="+STR$(Var.Value.iVal)

      CASE %VT_UI2
	    JAGetVariantTextTypeAndContent="%VT_UI2="+STR$(Var.Value.iVal)

      CASE %VT_I4
	    JAGetVariantTextTypeAndContent="%VT_I4="+STR$(Var.Value.iVal)

      CASE %VT_UI4
	    JAGetVariantTextTypeAndContent="%VT_UI4="+STR$(Var.Value.iVal)

      CASE %VT_R4
	    JAGetVariantTextTypeAndContent="%VT_R4="+STR$(Var.Value.fltVal)

      CASE %VT_R8
	    JAGetVariantTextTypeAndContent="%VT_R8="+STR$(Var.Value.dblVal)

      CASE %VT_BOOL
	    JAGetVariantTextTypeAndContent="%VT_BOOL="+STR$(Var.Value.boolVal)

      CASE %VT_CY
	    JAGetVariantTextTypeAndContent="%VT_CY="+STR$(Var.Value.cyVal)

      CASE %VT_UNKNOWN
	    JAGetVariantTextTypeAndContent="%VT_UNKNOWN="+STR$(Var.Value.punkVal)

      CASE %VT_DISPATCH
	    JAGetVariantTextTypeAndContent="%VT_DISPATCH="+STR$(Var.Value.pdispVal)

      CASE %VT_BSTR
	    psz=""
		IF (Var.Value.bstrVal <> 0) THEN
	      JAReadString Var.Value.bstrVal,psz
		END IF
	    JAGetVariantTextTypeAndContent="%VT_BSTR="+psz

      CASE ELSE
        IF ((Var.vt AND %VT_ARRAY) <> 0) THEN
		  vtarray=Var.vt AND NOT(%VT_ARRAY)
		  scontent="%VT_ARRAY("+JAGetVariantVTString(vtarray)+")"
		  IF (Var.Value.parray <> 0) THEN
		    scontent=scontent+" SafeArrayGetDim="+STR$(SafeArrayGetDim(Var.Value.parray))
		  ELSE
		    scontent=scontent+" parray=NULL"
		  END IF
	      JAGetVariantTextTypeAndContent=scontent
		END IF

  END SELECT

END FUNCTION

FUNCTION JAGetVariantTextContent(BYREF Var AS VARIANT) AS STRING
LOCAL psz AS ASCIIZ*4096
LOCAL vtarray AS WORD
LOCAL scontent AS STRING

  JAGetVariantTextContent=""

  SELECT CASE Var.vt

      CASE %VT_I1
	    JAGetVariantTextContent=STR$(Var.Value.bVal)

      CASE %VT_UI1
	    JAGetVariantTextContent=STR$(Var.Value.bVal)

      CASE %VT_I2
	    JAGetVariantTextContent=STR$(Var.Value.iVal)

      CASE %VT_UI2
	    JAGetVariantTextContent=STR$(Var.Value.iVal)

      CASE %VT_I4
	    JAGetVariantTextContent=STR$(Var.Value.iVal)

      CASE %VT_UI4
	    JAGetVariantTextContent=STR$(Var.Value.iVal)

      CASE %VT_R4
	    JAGetVariantTextContent=STR$(Var.Value.fltVal)

      CASE %VT_R8
	    JAGetVariantTextContent=STR$(Var.Value.dblVal)

      CASE %VT_BOOL
	    JAGetVariantTextContent=STR$(Var.Value.boolVal)

      CASE %VT_CY
	    JAGetVariantTextContent=STR$(Var.Value.cyVal)

      CASE %VT_UNKNOWN
	    JAGetVariantTextContent=STR$(Var.Value.punkVal)

      CASE %VT_DISPATCH
	    JAGetVariantTextContent=STR$(Var.Value.pdispVal)

      CASE %VT_BSTR
	    psz=""
		IF (Var.Value.bstrVal <> 0) THEN
	      JAReadString Var.Value.bstrVal,psz
		END IF
	    JAGetVariantTextContent=psz

  END SELECT

END FUNCTION

FUNCTION JASetVariant(BYREF Var AS VARIANT,pValue AS DWORD,BYVAL VT AS DWORD) AS DWORD
LOCAL hr AS DWORD
LOCAL pbyte AS BYTE PTR
LOCAL pword AS WORD PTR
LOCAL pdword AS DWORD PTR
LOCAL psingle AS SINGLE PTR
LOCAL pdouble AS DOUBLE PTR
LOCAL pcur AS CUR PTR
LOCAL pasciiz AS ASCIIZ PTR

  hr=0

  VariantClear Var

  IF (pValue=0) THEN
    hr=1
	goto LXJASetVariant
  END IF

  SELECT CASE VT

      CASE %VT_I1
        pbyte=pValue
		Var.vt=VT
		Var.Value.bVal=@pbyte

      CASE %VT_UI1
        pbyte=pValue
		Var.vt=VT
		Var.Value.bVal=@pbyte

      CASE %VT_I2
        pword=pValue
		Var.vt=VT
		Var.Value.iVal=@pword

      CASE %VT_UI2
        pword=pValue
		Var.vt=VT
		Var.Value.iVal=@pword

      CASE %VT_I4
        pdword=pValue
		Var.vt=VT
		Var.Value.lVal=@pdword

      CASE %VT_UI4
        pdword=pValue
		Var.vt=VT
		Var.Value.lVal=@pdword

      CASE %VT_R4
        psingle=pValue
		Var.vt=VT
		Var.Value.fltVal=@psingle

      CASE %VT_R8
        pdouble=pValue
		Var.vt=VT
		Var.Value.dblVal=@pdouble

      CASE %VT_BOOL
        pword=pValue
		Var.vt=VT
		Var.Value.boolVal=@pword

      CASE %VT_CY
        pcur=pValue
		Var.vt=VT
		Var.Value.cyVal=@pcur

      CASE %VT_UNKNOWN
        pdword=pValue
		Var.vt=VT
		Var.Value.punkVal=@pdword
		IF (Var.Value.punkVal <> 0) THEN
		  IUnknown_AddRef Var.Value.punkVal
		END IF

      CASE %VT_DISPATCH
        pdword=pValue
		Var.vt=VT
		Var.Value.pdispVal=@pdword
		IF (Var.Value.pdispVal <> 0) THEN
		  IUnknown_AddRef Var.Value.punkVal
		END IF

      CASE %VT_LPSTR
        pasciiz=pValue
		Var.vt=%VT_BSTR
		Var.Value.bstrVal=JAAllocString(@pasciiz)

      CASE %VT_BSTR
        pdword=pValue
		Var.vt=VT
		Var.Value.bstrVal=@pdword

  END SELECT

LXJASetVariant:
  JASetVariant=hr
END FUNCTION

FUNCTION JAGetVariant(BYREF Var AS VARIANT,pValue AS DWORD,BYVAL VT AS DWORD) AS DWORD
LOCAL hr AS DWORD
LOCAL h AS DWORD
LOCAL tvar AS VARIANT
LOCAL pbyte AS BYTE PTR
LOCAL pword AS WORD PTR
LOCAL pdword AS DWORD PTR
LOCAL psingle AS SINGLE PTR
LOCAL pdouble AS DOUBLE PTR
LOCAL pcur AS CUR PTR
LOCAL pasciiz AS ASCIIZ PTR

  hr=0

  VariantInit tvar

  IF (pValue=0) THEN
    hr=1
	goto LXJAGetVariant
  END IF

  h=VariantChangeType(tvar,Var,%VARIANT_NOVALUEPROP,VT)
  IF (h <> 0) THEN
    hr=2
	goto LXJAGetVariant
  END IF

  SELECT CASE VT

      CASE %VT_I1
        pbyte=pValue
		@pbyte=tvar.Value.bVal

      CASE %VT_UI1
        pbyte=pValue
		@pbyte=tvar.Value.bVal

      CASE %VT_I2
        pword=pValue
		@pword=tvar.Value.iVal

      CASE %VT_UI2
        pword=pValue
		@pword=tvar.Value.iVal

      CASE %VT_I4
        pdword=pValue
		@pdword=tvar.Value.lVal

      CASE %VT_UI4
        pdword=pValue
		@pdword=tvar.Value.lVal

      CASE %VT_R4
        psingle=pValue
		@psingle=tvar.Value.fltVal

      CASE %VT_R8
        pdouble=pValue
		@pdouble=tvar.Value.dblVal

      CASE %VT_BOOL
        pword=pValue
		@pword=tvar.Value.boolVal

      CASE %VT_CY
        pcur=pValue
		@pcur=tvar.Value.cyVal

      CASE %VT_UNKNOWN
        pdword=pValue
		@pdword=tvar.Value.punkVal
		IF (tvar.Value.punkVal <> 0) THEN
		  IUnknown_AddRef tvar.Value.punkVal
		END IF

      CASE %VT_DISPATCH
        pdword=pValue
		@pdword=tvar.Value.pdispVal
		IF (tvar.Value.pdispVal <> 0) THEN
		  IUnknown_AddRef tvar.Value.punkVal
		END IF

      CASE %VT_LPSTR
        pasciiz=pValue
		JAReadString tvar.Value.bstrVal,@pasciiz

      CASE %VT_BSTR
        pdword=pValue
		'@pdword=SysAllocString(tvar.Value.bstrVal)

  END SELECT

LXJAGetVariant:
  VariantClear tvar
  JAGetVariant=hr
END FUNCTION

FUNCTION JAEnumerate(pIEnum AS DWORD) AS DWORD
LOCAL hsa AS DWORD
LOCAL retcode AS LONG
LOCAL pienumvariant AS DWORD
LOCAL hr AS DWORD
LOCAL celtFetched AS DWORD
LOCAL var AS VARIANT
LOCAL goon AS BYTE
LOCAL nbenum AS DWORD
DIM abound AS SAFEARRAYBOUND
DIM indice AS LONG

  InitSTDOLEGUIDs

  hsa=0
  retcode=0
  pienumvariant=0

  IF (pIEnum=0) THEN
    retcode=1
    goto LXJAEnumerate
  END IF

  hr=IUnknown_QueryInterface(pIEnum,IID_IEnumVARIANT,VARPTR(pienumvariant))
  IF (COMFAILED(hr) <> 0) THEN
    retcode=2
    goto LXJAEnumerate
  END IF

  hr=IEnumVARIANT_Reset(pienumvariant)
  IF (COMFAILED(hr) <> 0) THEN
    retcode=3
    goto LXJAEnumerate
  END IF

  nbenum=0
  goon=1
  WHILE (goon <> 0)
    VariantInit var
    hr=IEnumVARIANT_Next(pienumvariant,1,var,celtFetched)
    IF (COMFAILED(hr) <> 0) OR (celtFetched < 1) THEN
	  goon=0
    ELSE
      VariantClear var
	  nbenum=nbenum+1
    END IF
  WEND

 IF (nbenum=0) THEN
    retcode=4
    goto LXJAEnumerate
  END IF

  hr=IEnumVARIANT_Reset(pienumvariant)
  IF (COMFAILED(hr) <> 0) THEN
    retcode=5
    goto LXJAEnumerate
  END IF

  abound.cElements=nbenum
  abound.lLBound=0

  hsa=SafeArrayCreate(%VT_VARIANT,1,abound)
  IF (hsa=0) THEN
    retcode=6
    goto LXJAEnumerate
  END IF

  goon=1
  indice=0
  WHILE (goon <> 0)
    VariantInit var
    hr=IEnumVARIANT_Next(pienumvariant,1,var,celtFetched)
    IF (COMFAILED(hr) <> 0) OR (celtFetched < 1) THEN
	  goon=0
    ELSE
      SafeArrayPutElement hsa,indice,VARPTR(var)
      VariantClear var
	  indice=indice+1
    END IF
  WEND

LXJAEnumerate:
  JARelease pienumvariant
  JAEnumerate=hsa
END FUNCTION
